eval '(exit $?0)' && eval 'exec perl -w -S $0 ${1+"$@"}'
    & eval 'exec perl -w -S $0 $argv:q'
    if 0;

use strict;

use Env '$OPALORB_ROOT';
use lib "$OPALORB_ROOT";
use CORBA;
use CORBA::Exception;
use MathModule::Math;

my $status = 0;

try {
    # obtain arguments
    my ($i, $ior_file, $x, $y);
    $i = 0;
    while ($i<$#ARGV) {  # not <= as will have args with at least 1 param
        if ($ARGV[$i] eq "-ior") {
            $ior_file=$ARGV[++$i];
        }
        if ($ARGV[$i] eq "-add") {
            $x=$ARGV[++$i];
            $y=$ARGV[++$i];
        } 
        $i++;
    }
    
  # initialize the ORB
  my $orb = CORBA::ORB_init(\@ARGV);

  # obtain an object reference
  my $ior = "file://$ior_file";
  my $obj = $orb->string_to_object($ior);
  if (CORBA::is_nil($obj)) {
    print STDERR "Unable to obtain a reference to the server\n";
    exit(1);
  }
  my $server = MathModule::Math::_narrow($obj);
  if (CORBA::is_nil($server)) {
    print "Narrow failed.\n";
    exit(1);
  }

  # invoke the method
  my $result = $server->Add($x,$y);
  print "Sum: $result\n";

  # cleanup
  $orb->destroy();
}
catch CORBA::Exception with {
  my $ex = shift;
  print STDERR "EXCEPTION: $ex\n";
  $status++;
};

exit($status);
